unit sADOControls;
(************************************************************************
sStyle components package 
Copyright (c) 2002 Serge Goncharov. All rights reserved.
                            Ukraine, Odessa
                            http://www.geocities.com/sstylish2002/
                            Serge@HyBce.com
 Version:	1.2, 24-02-2002
*************************************************************************)

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, StrUtils, ADODB, sCustomComboBox, sControls, sConst;

type
  {  @link(TsCustomComboBox)        
     .       @link(Connection) 
  @link(SQL)}
  TsADOComboBox = class(TsCustomComboBox)
  private
    { Private declarations }
  protected
    FConnection : TADOConnection;
    { Protected declarations }
  public
    {  }
    constructor Create(AOwner:TComponent); override;
    {   }
    function Generate : integer; override;
    { Public declarations }
  published
    property Enabled;
    property Font;
    property Hint;
    property ItemHeight;
    property Items;
    property MaxLength;
    property DropDownCount;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property ShowHint;
    property Sorted;
    property Style;
    property TabOrder;
    property Text;
    property Visible;
    property CharCase;
    property Connection:TADOConnection read FConnection write FConnection;
    property SQL;
    property sStyle;
    property CharsInCode;
    property OnDropDown;

    property OnChange;
    property OnClick;
    property OnContextPopup;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnDrawItem;
//    property OnDropDown;
    property OnEndDock;
    property OnEndDrag;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    property OnMeasureItem;
    property OnStartDock;
    property OnStartDrag;
    { Published declarations }
  end;

implementation

constructor TsADOComboBox.Create(AOwner:TComponent);
begin
  inherited Create(AOwner);
  sStyle.COC := COC_TsADOComboBox;
end;

function TsADOComboBox.Generate : integer;
var
  q: TADOQuery;
  s, t: string;
begin
  Result := -1;
  if Assigned(Connection) and (SQL.Text<>'') then begin
    q:=TADOQuery.Create(Self);
    q.Connection := Connection;
    q.SQL.Assign(SQL);
    q.Open;

    q.first;
    Clear;
    if sStyle.DefaultString<>'' then begin
      Items.Add(sStyle.DefaultString);
    end;
    while not q.eof do begin
      if (CharsInCode > 0) and (q.FieldCount > 1) then begin
       if Length(q.Fields[1].AsString) < CharsInCode then begin
         s:='0';
         while Length(s) < CharsInCode - length(q.Fields[1].AsString) do begin
           s:=s+'0';
         end;
         t := s + q.Fields[1].AsString + ' - ' + q.Fields[0].AsString;
       end
       else begin
         t := q.Fields[1].AsString + ' - ' + q.Fields[0].AsString;
       end;
      end
      else begin
        t := q.Fields[0].AsString;
      end;
      Items.Add(t);
      q.next;
    end;
    q.Free;
    if Items.Count < DropDownCount then begin
    end;
    Result := Items.Count;
    if sStyle.DefaultString <> '' then begin
      ItemIndex := 0;
    end;
  end;
end;

end.
